local arrayOfElements = {}


WeekKeys.AddInit(function()
local L = WeekKeys.L
local WeekFrame = WeekKeys.WeekFrame
WeekFrame.ClassBtn = {}
WeekFrame.SpecBtn = {}
WeekFrame.SlotBtn = {}
WeekFrame.LootBtn = {}

local mythic_level = {
    nil, -- index 1 -> mythic 1?
    6808,-- index 2 -> mythic 2
    6809,
    7203,
    7204,
    7205,
    7206,
    7207,
    7208,
    7209,
    7210,
    7211,
    7212,
    7213,
    7214
}

local end_of_run_ilvl = {
    nil,
    5845,
    5848,
    5852,
    5852,
    5852,
    5858,
    5858,
    5858,
    5861,
    5861,
    5865,
    5865,
    5865,
    5868
}

function WeekFrame.WPDropDownDemo_Menu1(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg2 = 0
    info.func = LootFinder.SetStat
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT","ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
end

function WeekFrame.WPDropDownDemo_Menu2(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg1 = 0
    info.func = LootFinder.SetStat
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
end

arrayOfElements[1] = CreateFrame('Frame')
arrayOfElements[1]:SetFrameStrata("BACKGROUND")
arrayOfElements[1]:SetSize(10,10)
arrayOfElements[1]:SetScript("OnShow",function()
    WeekFrame.ScrollFrame:ClearAllPoints()
    WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -300);
    WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
end)
arrayOfElements[1]:Hide()
for i = 1, 12 do
    arrayOfElements[i+1] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[i+1]:SetPoint("TOPLEFT",0+i*35,-35)
    arrayOfElements[i+1]:SetSize(35,35)
    arrayOfElements[i+1]:SetID(i)
    arrayOfElements[i+1].icon = arrayOfElements[i+1]:CreateTexture(nil,"BACKGROUND"); -- create texture as child of myframe
    arrayOfElements[i+1].icon:SetAllPoints(arrayOfElements[i+1]); -- copy dimensions of myframe to icon
    local _, class, _ = GetClassInfo(i)
   -- local _,class = UnitClass("player"); -- get non-localized class name
    arrayOfElements[i+1].icon:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES"); -- this is the image containing all class icons
    local coords = CLASS_ICON_TCOORDS[class]; -- get the coordinates of the class icon we want
    arrayOfElements[i+1].icon:SetTexCoord(unpack(coords)); -- cut out the region with our class icon according to coords
    arrayOfElements[i+1].icon2 = arrayOfElements[i+1]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[i+1].icon2:SetAllPoints(arrayOfElements[i+1]);
    arrayOfElements[i+1]:SetScript("onclick",function(self)
        self.icon2:SetColorTexture(1,1,1,0.3)
        if LootFinder.class ~= 0 and LootFinder.class ~= self:GetID() then
            WeekFrame.ClassBtn[LootFinder.class].icon2:SetColorTexture(1,1,1,0)
        end
        for k,v in pairs(WeekFrame.SpecBtn) do
            v.icon2:SetColorTexture(1,1,1,0)
        end
        LootFinder.class = self:GetID()
        LootFinder.spec = 0
        -- hide/show specialization button
        for j = 1, #WeekFrame.SpecBtn do
            if LootFinder.class_spec[LootFinder.class][j] == nil then
                WeekFrame.SpecBtn[j]:Hide()
            else
                local specID = LootFinder.class_spec[LootFinder.class][j]
                local _, _, _, icon, _, _ = GetSpecializationInfoByID(specID)
                WeekFrame.SpecBtn[j].icon:SetTexture(icon)
                WeekFrame.SpecBtn[j]:Show()
            end
        end
    end)
    arrayOfElements[i+1]:Hide()
    tinsert(WeekFrame.ClassBtn,arrayOfElements[i+1])
end
for i = 1, 4 do
    arrayOfElements[i+13] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[i+13]:SetPoint("TOPLEFT",150+i*35,-85)
    arrayOfElements[i+13]:SetSize(35,35)
    arrayOfElements[i+13]:SetID(i)
    arrayOfElements[i+13].icon = arrayOfElements[i+13]:CreateTexture(nil,"BACKGROUND");
    arrayOfElements[i+13].icon:SetAllPoints(arrayOfElements[i+13])
    arrayOfElements[i+13].icon2 = arrayOfElements[i+13]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[i+13].icon2:SetAllPoints(arrayOfElements[i+13]);
    tinsert(WeekFrame.SpecBtn,arrayOfElements[i+13])
    arrayOfElements[i+13]:SetScript("OnShow",function(self)
        if LootFinder.class == 0 then
            self:Hide()
            return
        end
    end)
    arrayOfElements[i+13]:SetScript("OnClick",function(self)
        self.icon2:SetColorTexture(1,1,1,0.3)
        for k,v in pairs(WeekFrame.SpecBtn) do
            if k ~= self:GetID() then
                v.icon2:SetColorTexture(1,1,1,0)
            end
        end
        LootFinder.spec = LootFinder.class_spec[LootFinder.class][self:GetID()]
    end)
end
--18
local icons = {133070,133292,135061,133771,132751,132616,132939,132511,134584,132535,135317,134959,801523,133441}
local slots = {0,1,2,3,4,5,6,7,8,9,10,11,12,13}
for i = 1, 14 do
    arrayOfElements[i+17] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[i+17]:SetPoint("TOPLEFT",-30+i*35,-145)
    arrayOfElements[i+17]:SetSize(35,35)
    arrayOfElements[i+17]:SetID(slots[i])
    arrayOfElements[i+17].icon = arrayOfElements[i+17]:CreateTexture(nil,"BACKGROUND");
    arrayOfElements[i+17].icon:SetAllPoints(arrayOfElements[i+17])
    arrayOfElements[i+17].icon:SetTexture(icons[i])
    arrayOfElements[i+17].icon2 = arrayOfElements[i+17]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[i+17].icon2:SetAllPoints(arrayOfElements[i+17]);
    arrayOfElements[i+17]:Hide()
    arrayOfElements[i+17]:SetScript("OnClick",function(self)
        LootFinder.slot = self:GetID()
        self.icon2:SetColorTexture(1,1,1,0.3)
        for k,v in pairs(WeekFrame.SlotBtn) do
            if v:GetID() ~= self:GetID() then
                v.icon2:SetColorTexture(1,1,1,0)
            end
        end
    end)
    tinsert(WeekFrame.SlotBtn,arrayOfElements[i+17])
end
--236372
--27:15 27:20
arrayOfElements[35] = CreateFrame("button",nil,WeekFrame)
arrayOfElements[35]:SetPoint("TOPLEFT",-30+14*35,-110)
arrayOfElements[35]:SetSize(35,35)
arrayOfElements[35].icon = arrayOfElements[35]:CreateTexture(nil,"CENTER");
arrayOfElements[35].icon:SetAllPoints(arrayOfElements[35])
arrayOfElements[35].icon:SetTexture(236372)
arrayOfElements[35]:Hide()
arrayOfElements[35]:SetScript("OnClick",function(self)
    LootFinder.slot = 15
    for k,v in pairs(WeekFrame.SlotBtn) do
        v.icon2:SetColorTexture(1,1,1,0)
    end
end)
arrayOfElements[35]:SetScript("OnEnter",function(self)
    GameTooltip:Hide();
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
    GameTooltip:AddLine(L["removeslot"],1,1,1)
    GameTooltip:Show()
end)
arrayOfElements[35]:SetScript("OnLeave",function(self)
    GameTooltip:Hide();
end)
--32
arrayOfElements[32] = CreateFrame("Frame", "Stating1", WeekFrame, "UIDropDownMenuTemplate")
arrayOfElements[32]:SetPoint("TOPLEFT",10,-190)
UIDropDownMenu_SetWidth(arrayOfElements[32], 100)
UIDropDownMenu_Initialize(arrayOfElements[32], WeekFrame.WPDropDownDemo_Menu1)
UIDropDownMenu_SetText(arrayOfElements[32],OPTIONAL)
arrayOfElements[32]:Hide()

arrayOfElements[33] = CreateFrame("Frame", "Stating2", WeekFrame, "UIDropDownMenuTemplate")
arrayOfElements[33]:SetPoint("TOPLEFT",10,-220)
UIDropDownMenu_SetWidth(arrayOfElements[33], 100)
UIDropDownMenu_Initialize(arrayOfElements[33], WeekFrame.WPDropDownDemo_Menu2)
UIDropDownMenu_SetText(arrayOfElements[33],OPTIONAL)
arrayOfElements[33]:Hide()

arrayOfElements[34] = CreateFrame("Button",nil,WeekFrame,"UIPanelButtonTemplate")
arrayOfElements[34]:SetPoint("TOPLEFT",30,-260)
arrayOfElements[34]:SetSize(120,30)
arrayOfElements[34]:SetText(SEARCH)
arrayOfElements[34]:SetScript("OnClick",function()
    LootFinder:Find()
    for i = 1, #WeekFrame.LootBtn do
        if LootFinder.LootList[i] then
            WeekFrame.LootBtn[i]:Hide()
            WeekFrame.LootBtn[i]:Show()
        else
            WeekFrame.LootBtn[i]:Hide()
        end
    end

    for i = #WeekFrame.LootBtn + 1,#LootFinder.LootList do
        local lInfo = CreateFrame('button', 'frameName', arrayOfElements[1], 'InsetFrameTemplate2')
        lInfo:SetID(i)
        local texture = lInfo:CreateTexture('textureName', 'BACKGROUND')
        texture:SetPoint('TOPLEFT', 2, -2)
        texture:SetPoint('bottomright', -2, 2)
        texture:SetColorTexture(0.2, 0.2, 0.2, 1)
        lInfo:SetHighlightTexture(texture)
        lInfo:DisableDrawLayer("BORDER")
        lInfo:SetNormalFontObject('GameFontNormal')
        lInfo:SetSize(WeekFrame:GetWidth()-8, 20)
        lInfo:SetPoint("TOPLEFT",4,-(i-1)*20)

        lInfo.instance = lInfo:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        lInfo.instance:SetPoint("LEFT",5,0)
        lInfo.instance:SetText(LootFinder.LootList[i][1])

        local itemname = GetItemInfo(LootFinder.LootList[i][2])
        lInfo.item = lInfo:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        lInfo.item:SetPoint("LEFT",160,0)
        lInfo.item:SetText("|cffffffff"..itemname)

        lInfo:SetScript("OnShow",function(self)
            local id = self:GetID()
            if not LootFinder.LootList[id] then
                self:Hide()
            end
            self.instance:SetText(LootFinder.LootList[id][1])

            local itemName = GetItemInfo(LootFinder.LootList[id][2])
            self.item:SetText("|cffffffff"..itemName)
        end)

        lInfo:SetScript("OnEnter",function(self)
            GameTooltip:Hide();
           -- LootFinder.level = 15
           --[[
               	"7206", -- [15] 158ilvl						x mythic
                "6652", -- [16] 158ilvl 7mythic 			???
                "1501", -- [17] 158ilvl 7mythic 			+ilvl? 1 (ItemLevel)
                "5845", -- [18] 187ilvl 7mythic				13 (ScalingStatDistributionFixed)	
                "6646", -- [19] 213ilvl 7mythic blue		13 (ScalingStatDistributionFixed)
           ]]
           local pattern = "5:"..mythic_level[LootFinder.level]..":6652:1501:"..end_of_run_ilvl[LootFinder.level]..":6646"
           -- a:gsub("%d+:3524:%d+:%d+:%d+:","5:7206:6652:1501:5871:6646")
            GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
            GameTooltip:SetHyperlink(LootFinder.LootList[self:GetID()][2]:gsub("%d+:3524:%d+:%d+:%d+:",pattern))
            
            GameTooltip:Show()
        end)
        lInfo:SetScript("OnLeave",function(self)
            GameTooltip:Hide();
        end)
        tinsert(WeekFrame.LootBtn,lInfo)
    end
end)
arrayOfElements[34]:Hide()

arrayOfElements[36] = CreateFrame("EditBox",nil,WeekFrame,"InputBoxTemplate")
arrayOfElements[36]:SetAutoFocus(false)
arrayOfElements[36]:SetPoint("TOPLEFT",-30+12*35,-220)
arrayOfElements[36]:SetSize(50,20)
arrayOfElements[36]:SetNumber(15)
arrayOfElements[36]:ClearFocus()
arrayOfElements[36]:SetMaxLetters(2)
arrayOfElements[36]:SetNumeric(true)

arrayOfElements[36]:SetScript("OnEditFocusLost",function(self)
    LootFinder.level = max(self:GetNumber(), 2)
    C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
    self:ClearFocus()
end)

arrayOfElements[36]:SetScript("OnEnterPressed",function(self)
    self:ClearFocus()
end)

arrayOfElements[36]:SetScript("OnShow",function()
    C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
end)
arrayOfElements[36]:SetScript("OnHide",function()
    C_EncounterJournal.SetPreviewMythicPlusLevel(0)
end)

arrayOfElements[36]:Hide()

arrayOfElements[37] = WeekFrame:CreateFontString(nil , "BORDER", "GameFontNormal")
arrayOfElements[37]:SetPoint("TOPLEFT",-30+12*35,-200)
arrayOfElements[37]:SetText(GUILD_RECRUITMENT_LEVEL)
arrayOfElements[37]:Hide()

local iIndex = 1
EJ_SelectTier(LootFinder.expansion)
while EJ_GetInstanceByIndex(iIndex, false) ~= nil do
    LootFinder.instances[iIndex] = true
    local _, name, _, bgim, buttonImage1, loreImage, buttonImage2 = EJ_GetInstanceByIndex(iIndex, false)
   -- print(bgim,buttonImage1, loreImage, buttonImage2)
    arrayOfElements[iIndex+37] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[iIndex+37].name = name
    arrayOfElements[iIndex+37]:SetPoint("TOPLEFT",160+((iIndex-1)%6)*35,-210-math.floor((iIndex-1)/6)*35)
    arrayOfElements[iIndex+37]:SetSize(35,35)
    arrayOfElements[iIndex+37]:SetID(iIndex)
    arrayOfElements[iIndex+37].icon = arrayOfElements[iIndex+37]:CreateTexture(nil,"BACKGROUND");
    arrayOfElements[iIndex+37].icon:SetAllPoints(arrayOfElements[iIndex+37])
    arrayOfElements[iIndex+37].icon:SetTexture(buttonImage2)
    arrayOfElements[iIndex+37].icon2 = arrayOfElements[iIndex+37]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[iIndex+37].icon2:SetAllPoints(arrayOfElements[iIndex+37]);
    local btn = arrayOfElements[iIndex+37]
    btn.find = true
    function btn:enable(bool)
        if bool then
            LootFinder.instances[self:GetID()] = true
            self.icon2:SetColorTexture(0,0,0,0)
        else
            LootFinder.instances[self:GetID()] = false
            self.icon2:SetColorTexture(0,0,0,0.6)
        end
        self.find = bool
    end
    arrayOfElements[iIndex+37]:SetScript("OnClick",function(self)
        self:enable(not self.find)
    end)
    arrayOfElements[iIndex+37]:SetScript("OnEnter",function(self)
        GameTooltip:Hide();
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
        GameTooltip:AddLine(self.name)
        GameTooltip:Show()
    end)
    arrayOfElements[iIndex+37]:SetScript("OnLeave",function(self)
        GameTooltip:Hide();
    end)
    arrayOfElements[iIndex+37]:Hide()
    iIndex = iIndex + 1
end

WeekKeys.AddButton(L["lootfinder"],arrayOfElements)
end)